Index: /branches/version-2_12-dev/data/class/pages/admin/order/LC_Page_Admin_Order_Edit.php
===================================================================
--- /branches/version-2_12-dev/data/class/pages/admin/order/LC_Page_Admin_Order_Edit.php	(revision 22567)
+++ /branches/version-2_12-dev/data/class/pages/admin/order/LC_Page_Admin_Order_Edit.php	(revision 22796)
@@ -701,6 +645,5 @@
      * エラー発生時は負数を返す。
      */
-    function doRegister($order_id, &$objPurchase, &$objFormParam, &$message, &$arrValuesBefore)
-    {
+    function doRegister($order_id, &$objPurchase, &$objFormParam, &$message, &$arrValuesBefore) {
 
         $objQuery =& SC_Query_Ex::getSingletonInstance();
@@ -729,6 +672,4 @@
                 'classcategory_name1',
                 'classcategory_name2',
-                'tax_rate',
-                'tax_rule'
         ));
 
@@ -781,8 +722,7 @@
         $arrAllShipmentItem = $objFormParam->getSwapArray($this->arrShipmentItemKeys);
 
-        $arrDelivTime = SC_Helper_Delivery_Ex::getDelivTime($objFormParam->getValue('deliv_id'));
-        //商品単価を複数配送にも適応
+        $arrDelivTime = $objPurchase->getDelivTime($objFormParam->getValue('deliv_id'));
+
         $arrShippingValues = array();
-        $arrIsNotQuantityUp = array();
         foreach ($arrAllShipping as $shipping_index => $arrShipping) {
             $shipping_id = $arrShipping['shipping_id'];
@@ -794,12 +734,4 @@
                                               $arrShipping['shipping_date_day']);
 
-            //商品単価を複数配送にも反映する
-            foreach ($arrDetail as $product_detail) {
-                foreach ($arrAllShipmentItem[$shipping_index]['shipment_product_class_id'] as $relation_index => $shipment_product_class_id) {
-                    if($product_detail['product_class_id'] == $shipment_product_class_id){
-                        $arrAllShipmentItem[$shipping_index]['shipment_price'][$relation_index] = $product_detail['price'];
-                    }
-                }
-            }
             // 配送業者IDを取得
             $arrShippingValues[$shipping_index]['deliv_id'] = $objFormParam->getValue('deliv_id');
@@ -823,5 +755,4 @@
             }
         }
-
         $objPurchase->registerShipping($order_id, $arrShippingValues, false);
         $objQuery->commit();
@@ -837,13 +768,72 @@
      * @return void
      */
-    function doRegisterProduct(&$objFormParam)
-    {
+    function doRegisterProduct(&$objFormParam) {
         $product_class_id = $objFormParam->getValue('add_product_class_id');
         if (SC_Utils_Ex::isBlank($product_class_id)) {
             $product_class_id = $objFormParam->getValue('edit_product_class_id');
             $changed_no = $objFormParam->getValue('no');
-            $this->shipmentEditProduct($objFormParam, $product_class_id, $changed_no);
-        }else{
-            $this->shipmentAddProduct($objFormParam, $product_class_id);
+        }
+        // FXIME バリデーションを通さず $objFormParam の値で DB 問い合わせしている。(管理機能ため、さほど問題は無いと思うものの…)
+
+        // 商品規格IDが指定されていない場合、例外エラーを発生
+        if (strlen($product_class_id) === 0) {
+            trigger_error('商品規格指定なし', E_USER_ERROR);
+        }
+
+        // 選択済みの商品であれば数量を1増やす
+        $exists = false;
+        $arrExistsProductClassIds = $objFormParam->getValue('product_class_id');
+        foreach ($arrExistsProductClassIds as $key => $value) {
+            $exists_product_class_id = $arrExistsProductClassIds[$key];
+            if ($exists_product_class_id == $product_class_id) {
+                $exists = true;
+                $exists_no = $key;
+                $arrExistsQuantity = $objFormParam->getValue('quantity');
+                $arrExistsQuantity[$key]++;
+                $objFormParam->setValue('quantity', $arrExistsQuantity);
+            }
+        }
+
+        // 新しく商品を追加した場合はフォームに登録
+        // 商品を変更した場合は、該当行を変更
+        if (!$exists) {
+            $objProduct = new SC_Product_Ex();
+            $arrProduct = $objProduct->getDetailAndProductsClass($product_class_id);
+
+            // 一致する商品規格がない場合、例外エラーを発生
+            if (empty($arrProduct)) {
+                trigger_error('商品規格一致なし', E_USER_ERROR);
+            }
+
+            $arrProduct['quantity'] = 1;
+            $arrProduct['price'] = $arrProduct['price02'];
+            $arrProduct['product_name'] = $arrProduct['name'];
+
+            $arrUpdateKeys = array(
+                'product_id', 'product_class_id', 'product_type_id', 'point_rate',
+                'product_code', 'product_name', 'classcategory_name1', 'classcategory_name2',
+                'quantity', 'price',
+            );
+            foreach ($arrUpdateKeys as $key) {
+                $arrValues = $objFormParam->getValue($key);
+                // FIXME getValueで文字列が返る場合があるので配列であるかをチェック
+                if (!is_array($arrValues)) {
+                    $arrValues = array();
+                }
+
+                if (isset($changed_no)) {
+                    $arrValues[$changed_no] = $arrProduct[$key];
+                } else {
+                    $added_no = 0;
+                    if (is_array($arrExistsProductClassIds)) {
+                        $added_no = count($arrExistsProductClassIds);
+                    }
+                    $arrValues[$added_no] = $arrProduct[$key];
+                }
+                $objFormParam->setValue($key, $arrValues);
+            }
+        } elseif (isset($changed_no) && $exists_no != $changed_no) {
+            // 変更したが、選択済みの商品だった場合は、変更対象行を削除。
+            $this->doDeleteProduct($changed_no, $objFormParam);
         }
     }
@@ -856,31 +846,19 @@
      * @return void
      */
-    function doDeleteProduct($delete_no, &$objFormParam)
-    {
-
-        $select_shipping_id    = $objFormParam->getValue('select_shipping_id');
-
-        //変更前のproduct_class_idが他の届け先にも存在するか
-        $arrPreShipmentProductClassIds = $objFormParam->getValue('shipment_product_class_id');
-        $arrPreProductClassIds         = $objFormParam->getValue('product_class_id');
-        $delete_product_class_id       = $arrPreShipmentProductClassIds[$select_shipping_id][$delete_no];
-
-        //配送先データ削除
-        $arrNewShipments = $this->deleteShipment($objFormParam, $this->arrShipmentItemKeys , $select_shipping_id, $delete_no);
-        $objFormParam->setParam($arrNewShipments);
-
-        $is_product_delete = true;
-        foreach ($arrNewShipments['shipment_product_class_id'] as $shipping_id => $arrShipmentProductClassIds) {
-            foreach ($arrShipmentProductClassIds as $relation_index => $shipment_product_class_id) {
-                if(in_array($delete_product_class_id, $arrShipmentProductClassIds)){
-                    $is_product_delete = false;
-                    break;
-                }
-            }
-        }
-
-        //商品情報から削除
-        if($is_product_delete){
-            $this->checkDeleteProducts($objFormParam, $arrPreProductClassIds, $delete_product_class_id, $this->arrProductKeys);
+    function doDeleteProduct($delete_no, &$objFormParam) {
+        $arrDeleteKeys = array(
+            'product_id', 'product_class_id', 'product_type_id', 'point_rate',
+            'product_code', 'product_name', 'classcategory_name1', 'classcategory_name2',
+            'quantity', 'price',
+        );
+        foreach ($arrDeleteKeys as $key) {
+            $arrNewValues = array();
+            $arrValues = $objFormParam->getValue($key);
+            foreach ($arrValues as $index => $val) {
+                if ($index != $delete_no) {
+                    $arrNewValues[] = $val;
+                }
+            }
+            $objFormParam->setValue($key, $arrNewValues);
         }
     }
@@ -892,6 +870,5 @@
      * @return void
      */
-    function addShipping(&$objFormParam)
-    {
+    function addShipping(&$objFormParam) {
         $objFormParam->setValue('shipping_quantity',
                                 $objFormParam->getValue('shipping_quantity') + 1);
@@ -908,6 +885,5 @@
      * @return void
      */
-    function setCustomerTo($customer_id, &$objFormParam)
-    {
+    function setCustomerTo($customer_id, &$objFormParam) {
         $arrCustomer = SC_Helper_Customer_Ex::sfGetCustomerDataFromId($customer_id);
         foreach ($arrCustomer as $key => $val) {
@@ -916,6 +892,4 @@
         $objFormParam->setValue('customer_id', $customer_id);
         $objFormParam->setValue('customer_point', $arrCustomer['point']);
-
-        return $arrCustomer['birth'];
     }
 
@@ -926,6 +900,5 @@
      * @return アンカーキーの文字列
      */
-    function getAnchorKey(&$objFormParam)
-    {
+    function getAnchorKey(&$objFormParam) {
         $ancor_key = $objFormParam->getValue('anchor_key');
         if (!SC_Utils_Ex::isBlank($ancor_key)) {
@@ -934,247 +907,3 @@
         return '';
     }
-
-    /**
-     * 商品を追加
-     *
-     * @param SC_FormParam $objFormParam SC_FormParam インスタンス
-     * @param integer $add_product_class_id 追加商品規格ID
-     * @return void
-     */
-    function shipmentAddProduct(&$objFormParam, $add_product_class_id)
-    {
-
-        //複数配送に商品情報追加
-        $select_shipping_id = $objFormParam->getValue('select_shipping_id');
-
-        //届け先に選択済みの商品がある場合
-        $arrShipmentProducts = $this->getShipmentProducts($objFormParam);
-
-        if(in_array($add_product_class_id, $arrShipmentProducts['shipment_product_class_id'][$select_shipping_id])){
-            foreach ($arrShipmentProducts['shipment_product_class_id'][$select_shipping_id] as $relation_index => $shipment_product_class_id) {
-                if($shipment_product_class_id == $add_product_class_id){
-                    $arrShipmentProducts['shipment_quantity'][$select_shipping_id][$relation_index]++;
-                    break;
-                }
-            }
-        }else{
-
-            //届け先に選択商品がない場合
-            $objProduct = new SC_Product_Ex();
-            $arrAddProductInfo = $objProduct->getDetailAndProductsClass($add_product_class_id);
-
-            $arrShipmentProducts['shipment_product_class_id'][$select_shipping_id][] = $add_product_class_id;
-            $arrShipmentProducts['shipment_product_code'][$select_shipping_id][]     = $arrAddProductInfo['product_code'];
-            $arrShipmentProducts['shipment_product_name'][$select_shipping_id][]     = $arrAddProductInfo['name'];
-            $arrShipmentProducts['shipment_price'][$select_shipping_id][]            = $arrAddProductInfo['price02'];
-            $arrShipmentProducts['shipment_quantity'][$select_shipping_id][]         = 1;
-
-            //受注商品情報に追加
-            $arrPreProductClassIds = $objFormParam->getValue('product_class_id');
-            $arrProducts = $this->checkInsertOrderProducts($objFormParam, $arrPreProductClassIds, $add_product_class_id, $arrAddProductInfo);
-            $objFormParam->setParam($arrProducts);
-        }
-        $objFormParam->setParam($arrShipmentProducts);
-    }
-
-    /**
-     * 商品を変更
-     *
-     * @param SC_FormParam $objFormParam SC_FormParam インスタンス
-     * @param integer $add_product_class_id 変更商品規格ID
-     * @param integer $change_no 変更対象
-     * @return void
-     */
-    function shipmentEditProduct(&$objFormParam, $edit_product_class_id, $change_no)
-    {
-        $arrPreProductClassIds = $objFormParam->getValue('product_class_id');
-        $select_shipping_id    = $objFormParam->getValue('select_shipping_id');
-
-        $arrShipmentProducts = $this->getShipmentProducts($objFormParam);
-
-        //既にあるデータは１つだけ数量を１増やす
-        $pre_shipment_product_class_id = $arrShipmentProducts['shipment_product_class_id'][$select_shipping_id][$change_no];
-        if($pre_shipment_product_class_id == $edit_product_class_id) {
-            $arrShipmentProducts['shipment_quantity'][$select_shipping_id][$change_no] ++;
-        }elseif(in_array($edit_product_class_id, $arrShipmentProducts['shipment_product_class_id'][$select_shipping_id])){
-            //配送先データ削除
-            $arrShipmentProducts = $this->deleteShipment($objFormParam, $this->arrShipmentItemKeys , $select_shipping_id, $change_no);
-            foreach ($arrShipmentProducts['shipment_product_class_id'][$select_shipping_id] as $relation_index => $shipment_product_class_id) {
-                if($shipment_product_class_id == $edit_product_class_id){
-                    $arrShipmentProducts['shipment_quantity'][$select_shipping_id][$relation_index] ++;
-                    break;
-                }
-            }
-        }else{
-            $objProduct = new SC_Product_Ex();
-            $arrAddProductInfo = $objProduct->getDetailAndProductsClass($edit_product_class_id);
-
-            //上書き
-            $this->changeShipmentProducts($arrShipmentProducts, $arrAddProductInfo, $select_shipping_id, $change_no);
-            //受注商品情報に追加
-            $arrProducts = $this->checkInsertOrderProducts($objFormParam, $arrPreProductClassIds, $edit_product_class_id, $arrAddProductInfo);
-            $objFormParam->setParam($arrProducts);
-        }
-        $objFormParam->setParam($arrShipmentProducts);
-
-        //更新のみの場合、全配列を持っていないので、新しい配列を取得
-        $arrNewShipmentProducts = $this->getShipmentProducts($objFormParam);
-        $is_product_delete = true;
-        //変更前のproduct_class_idが他の届け先にも存在するか
-        foreach ($arrNewShipmentProducts['shipment_product_class_id'] as $shipping_id => $arrShipmentProductClassIds) {
-            if(in_array($pre_shipment_product_class_id, $arrShipmentProductClassIds)){
-                $is_product_delete = false;
-                break;
-            }
-        }
-
-        //商品情報から削除
-        if($is_product_delete){
-            $this->checkDeleteProducts($objFormParam, $arrPreProductClassIds, $pre_shipment_product_class_id, $this->arrProductKeys);
-        }
-    }
-
-    /**
-     * 複数配送のパラメータを取り出す 
-     *
-     * @param SC_FormParam $objFormParam SC_FormParam インスタンス
-     * @return array 配送データ
-     */
-    function getShipmentProducts(&$objFormParam)
-    {
-        $arrShipmentProducts['shipment_product_class_id']    = $objFormParam->getValue('shipment_product_class_id');
-        $arrShipmentProducts['shipment_product_code']        = $objFormParam->getValue('shipment_product_code');
-        $arrShipmentProducts['shipment_product_name']        = $objFormParam->getValue('shipment_product_name');
-        $arrShipmentProducts['shipment_classcategory_name1'] = $objFormParam->getValue('shipment_classcategory_name1');
-        $arrShipmentProducts['shipment_classcategory_name2'] = $objFormParam->getValue('shipment_classcategory_name2');
-        $arrShipmentProducts['shipment_price']               = $objFormParam->getValue('shipment_price');
-        $arrShipmentProducts['shipment_quantity']            = $objFormParam->getValue('shipment_quantity');
-
-        return $arrShipmentProducts;
-    }
-
-    /**
-     * 変更対象のデータを上書きする
-     *
-     * @param array   $arrShipmentProducts  変更対象配列
-     * @param array   $arrProductInfo       上書きデータ
-     * @param integer $shipping_id          配送先ID
-     * @param array   $no                   変更対象
-     * @return void
-     */
-    function changeShipmentProducts(&$arrShipmentProducts, $arrProductInfo, $shipping_id, $no)
-    {
-        $arrShipmentProducts['shipment_product_class_id'][$shipping_id][$no]    = $arrProductInfo['product_class_id'];
-        $arrShipmentProducts['shipment_product_code'][$shipping_id][$no]        = $arrProductInfo['product_code'];
-        $arrShipmentProducts['shipment_product_name'][$shipping_id][$no]        = $arrProductInfo['name'];
-        $arrShipmentProducts['shipment_classcategory_name1'][$shipping_id][$no] = $arrProductInfo['classcategory_name1'];
-        $arrShipmentProducts['shipment_classcategory_name2'][$shipping_id][$no] = $arrProductInfo['classcategory_name2'];
-        $arrShipmentProducts['shipment_price'][$shipping_id][$no]               = $arrProductInfo['price02'];
-        $arrShipmentProducts['shipment_quantity'][$shipping_id][$no]            = 1;
-    }
-
-    /**
-     * 商品側の総量計算&セット
-     *
-     * @param SC_FormParam $objFormParam SC_FormParam インスタンス
-     * @return void
-     */
-    function setProductsQuantity(&$objFormParam)
-    {
-        $arrShipmentsItems = $objFormParam->getSwapArray(array('shipment_product_class_id','shipment_quantity'));
-        foreach ($arrShipmentsItems as $arritems) {
-            foreach ($arritems['shipment_product_class_id'] as $relation_index => $shipment_product_class_id) {
-                $arrUpdateQuantity[$shipment_product_class_id] += $arritems['shipment_quantity'][$relation_index];
-            }
-        }
-
-        $arrProductsClass = $objFormParam->getValue('product_class_id');
-        $arrProductsQuantity = $objFormParam->getValue('quantity');
-        foreach ($arrProductsClass as $relation_key => $product_class_id) {
-            $arrQuantity['quantity'][$relation_key] = $arrUpdateQuantity[$product_class_id];
-        }
-        $objFormParam->setParam($arrQuantity);
-    }
-
-    /**
-     * 削除対象の確認、削除をする
-     *
-     * @param SC_FormParam $objFormParam SC_FormParam インスタンス
-     * @param array   $arrProductClassIds　     削除対象配列の商品規格ID
-     * @param integer $delete_product_class_id　削除商品規格ID
-     * @param array   $arrDeleteKeys            削除項目
-     * @return void
-     */
-    function checkDeleteProducts(&$objFormParam, $arrProductClassIds, $delete_product_class_id, $arrDeleteKeys)
-    {
-        foreach ($arrProductClassIds as $relation_index => $product_class_id) {
-            //product_class_idの重複はないので、１つ削除したら完了
-            if($product_class_id == $delete_product_class_id){
-                foreach ($arrDeleteKeys as $delete_key) {
-                    $arrProducts = $objFormParam->getValue($delete_key);
-                    foreach ($arrProducts as $index => $product_info) {
-                        if($index != $relation_index){
-                            $arrUpdateParams[$delete_key][] = $product_info;
-                        }
-                    }
-                    $objFormParam->setParam($arrUpdateParams);
-                }
-                break;
-            }
-        }
-    }
-
-    /**
-     * 配送先商品の削除の削除
-     *
-     * @param SC_FormParam $objFormParam SC_FormParam インスタンス
-     * @param array   $arrShipmentDeleteKeys   削除項目
-     * @param integer $delete_shipping_id　    削除配送ID
-     * @param array   $delete_no               削除対象
-     * @return void
-     */
-    function deleteShipment(&$objFormParam, $arrShipmentDeletKeys, $delete_shipping_id, $delete_no)
-    {
-            foreach ($arrShipmentDeletKeys as $delete_key) {
-                $arrShipments = $objFormParam->getValue($delete_key);
-                foreach ($arrShipments as $shipp_id => $arrKeyData){
-                    foreach ($arrKeyData as $relation_index => $shipment_info) {
-                        if($relation_index != $delete_no || $shipp_id != $delete_shipping_id){
-                            $arrUpdateParams[$delete_key][$shipp_id][] = $shipment_info;
-                        }
-                    }
-                }
-            }
-            //$objFormParam->setParam($arrUpdateParams);
-            return $arrUpdateParams;
-        }
-
-
-    /**
-     * 受注商品一覧側に商品を追加
-     *
-     * @param SC_FormParam $objFormParam SC_FormParam インスタンス
-     * @param array   $arrProductClassIds　     対象配列の商品規格ID
-     * @param integer $indert_product_class_id　追加商品規格ID
-     * @param array   $arrAddProductInfo        追加データ
-     * @return array  $arrAddProducts           更新データ
-     */
-    function checkInsertOrderProducts(&$objFormParam, $arrProductClassIds, $insert_product_class_id, $arrAddProductInfo)
-    {
-        if(!in_array($insert_product_class_id, $arrProductClassIds)){
-            $arrAddProductInfo['product_name'] = ($arrAddProductInfo['product_name'])? $arrAddProductInfo['product_name']:$arrAddProductInfo['name'];
-            $arrAddProductInfo['price']        = ($arrAddProductInfo['price'])? $arrAddProductInfo['price']:$arrAddProductInfo['price02'];
-            $arrAddProductInfo['quantity']     = 1;
-            $arrAddProductInfo['tax_rate']     = ($objFormParam->getValue('order_tax_rate') == '')? $this->arrInfo['tax']     :$objFormParam->getValue('order_tax_rate');
-            $arrAddProductInfo['tax_rule']     = ($objFormParam->getValue('order_tax_rule') == '')? $this->arrInfo['tax_rule']:$objFormParam->getValue('order_tax_rule');
-            foreach ($this->arrProductKeys as $insert_key) {
-                $arrAddProducts[$insert_key]   = $objFormParam->getValue($insert_key);
-                $arrAddProducts[$insert_key][] = $arrAddProductInfo[$insert_key];
-            }
-            return $arrAddProducts;
-        }else{
-            //受注商品の数量は、複数配送側の集計で出しているので、重複しても数量を増やさない。
-            return null;
-        }
-    }
 }
Index: /branches/version-2_12-dev/data/class/pages/admin/contents/LC_Page_Admin_Contents_Recommend.php
===================================================================
--- /branches/version-2_12-dev/data/class/pages/admin/contents/LC_Page_Admin_Contents_Recommend.php	(revision 22582)
+++ /branches/version-2_12-dev/data/class/pages/admin/contents/LC_Page_Admin_Contents_Recommend.php	(revision 22796)
@@ -32,6 +32,5 @@
  * @version $Id$
  */
-class LC_Page_Admin_Contents_Recommend extends LC_Page_Admin_Ex 
-{
+class LC_Page_Admin_Contents_Recommend extends LC_Page_Admin_Ex {
 
     // }}}
@@ -43,6 +42,5 @@
      * @return void
      */
-    function init()
-    {
+    function init() {
         parent::init();
         $this->tpl_mainpage = 'contents/recommend.tpl';
@@ -60,6 +58,5 @@
      * @return void
      */
-    function process()
-    {
+    function process() {
         $this->action();
         $this->sendResponse();
@@ -71,32 +68,37 @@
      * @return void
      */
-    function action()
-    {
+    function action() {
         $objFormParam = new SC_FormParam_Ex();
         $this->lfInitParam($objFormParam);
         $objFormParam->setParam($_POST);
         $objFormParam->convParam();
-        $arrPost = $objFormParam->getHashArray();
-
-        $objRecommend = new SC_Helper_Recommend_Ex();
+        $objQuery =& SC_Query_Ex::getSingletonInstance();
+        $objDb = new SC_Helper_DB_Ex();
 
         switch ($this->getMode()) {
-            case 'down': //商品の並び替えをする。
-                $objRecommend->rankDown($arrPost['best_id']);
-                $arrItems = $this->getRecommendProducts($objRecommend);
-                break;
-
-            case 'up': //商品の並び替えをする。
-                $objRecommend->rankUp($arrPost['best_id']);
-                $arrItems = $this->getRecommendProducts($objRecommend);
+            case 'down': //商品の並び替えをする。おすすめはデータベースの登録が昇順なので、Modeを逆にする。
+                $arrRet = $objQuery->select('best_id', 'dtb_best_products', 'rank = ?', array($_POST['rank'])); //おすすめidの取得
+                $best_id = $arrRet[0]['best_id'];
+                $objDb->sfRankUp('dtb_best_products','best_id',$best_id);
+                $arrPost = $objFormParam->getHashArray();
+                $arrItems = $this->getRecommendProducts();
+                break;
+
+            case 'up': //商品の並び替えをする。おすすめのみデータベースの登録が昇順なので、Modeを逆にする。
+                $arrRet = $objQuery->select('best_id', 'dtb_best_products', 'rank = ?', array($_POST['rank'])); //おすすめidの取得
+                $best_id = $arrRet[0]['best_id'];
+                $objDb->sfRankDown('dtb_best_products','best_id',$best_id);
+                $arrPost = $objFormParam->getHashArray();
+                $arrItems = $this->getRecommendProducts();
                 break;
 
             case 'regist': // 商品を登録する。
                 $this->arrErr = $this->lfCheckError($objFormParam);
+                $arrPost = $objFormParam->getHashArray();
                 // 登録処理にエラーがあった場合は商品選択の時と同じ処理を行う。
                 if (SC_Utils_Ex::isBlank($this->arrErr)) {
                     $member_id = $_SESSION['member_id'];
-                    $this->insertRecommendProduct($arrPost,$member_id,$objRecommend);
-                    $arrItems = $this->getRecommendProducts($objRecommend);
+                    $this->insertRecommendProduct($arrPost,$member_id);
+                    $arrItems = $this->getRecommendProducts();
                 } else {
                     $arrItems = $this->setProducts($arrPost, $arrItems);
@@ -107,7 +109,8 @@
             case 'delete': // 商品を削除する。
                 $this->arrErr = $this->lfCheckError($objFormParam);
+                $arrPost = $objFormParam->getHashArray();
                 if (SC_Utils_Ex::isBlank($this->arrErr)) {
-                    $this->deleteProduct($arrPost, $objRecommend);
-                    $arrItems = $this->getRecommendProducts($objRecommend);
+                    $this->deleteProduct($arrPost);
+                    $arrItems = $this->getRecommendProducts();
                 }
                 $this->tpl_onload = "window.alert('削除しました');";
@@ -117,10 +120,10 @@
                 $arrPost = $objFormParam->getHashArray();
                 if (SC_Utils_Ex::isBlank($this->arrErr['rank']) && SC_Utils_Ex::isBlank($this->arrErr['product_id'])) {
-                    $arrItems = $this->setProducts($arrPost, $this->getRecommendProducts($objRecommend));
+                    $arrItems = $this->setProducts($arrPost, $this->getRecommendProducts());
                     $this->checkRank = $arrPost['rank'];
                 }
                 break;
             default:
-                $arrItems = $this->getRecommendProducts($objRecommend);
+                $arrItems = $this->getRecommendProducts();
                 break;
         }
@@ -140,6 +143,5 @@
      * @return void
      */
-    function destroy()
-    {
+    function destroy() {
         parent::destroy();
     }
@@ -149,7 +151,5 @@
      * @param Object $objFormParam
      */
-    function lfInitParam(&$objFormParam)
-    {
-        $objFormParam->addParam('おすすめ商品ID', 'best_id', INT_LEN, 'n', array('NUM_CHECK', 'MAX_LENGTH_CHECK'));
+    function lfInitParam(&$objFormParam) {
         $objFormParam->addParam('商品ID', 'product_id', INT_LEN, 'n', array('EXIST_CHECK', 'NUM_CHECK', 'MAX_LENGTH_CHECK'));
         $objFormParam->addParam('カテゴリID', 'category_id', INT_LEN, 'n', array('EXIST_CHECK', 'NUM_CHECK', 'MAX_LENGTH_CHECK'));
@@ -163,6 +163,5 @@
      * @return Array エラー内容
      */
-    function lfCheckError(&$objFormParam)
-    {
+    function lfCheckError(&$objFormParam) {
         $objErr = new SC_CheckError_Ex($objFormParam->getHashArray());
         $objErr->arrErr = $objFormParam->checkError();
@@ -172,24 +171,17 @@
     /**
      * 既に登録されている内容を取得する
-     * @param Object $objRecommend
      * @return Array $arrReturnProducts データベースに登録されているおすすめ商品の配列
      */
-    function getRecommendProducts(SC_Helper_Recommend_Ex &$objRecommend)
-    {
-        $arrList = $objRecommend->getList();
-        // product_id の一覧を作成
-        $product_ids = array();
-        foreach ($arrList as $value) {
-            $product_ids[] = $value['product_id'];
-        }
-
-        $objProduct = new SC_Product_Ex;
-        $objQuery = $objQuery =& SC_Query_Ex::getSingletonInstance();
-        $arrProducts = $objProduct->getListByProductIds($objQuery, $product_ids);
+    function getRecommendProducts() {
+        $objQuery = $objQuery =& SC_Query_Ex::getSingletonInstance();
+        $col = 'dtb_products.name,dtb_products.main_list_image,dtb_best_products.*';
+        $table = 'dtb_best_products INNER JOIN dtb_products ON dtb_best_products.product_id = dtb_products.product_id';
+        $where = 'dtb_best_products.del_flg = 0';
+        $order = 'rank';
+        $objQuery->setOrder($order);
+        $arrProducts = $objQuery->select($col, $table, $where);
 
         $arrReturnProducts = array();
-        foreach ($arrList as $data) {
-            $data['main_list_image'] = $arrProducts[$data['product_id']]['main_list_image'];
-            $data['name'] = $arrProducts[$data['product_id']]['name'];
+        foreach ($arrProducts as $data) {
             $arrReturnProducts[$data['rank']] = $data;
         }
@@ -201,10 +193,9 @@
      * @param Array $arrPost POSTの値を格納した配列
      * @param Integer $member_id 登録した管理者を示すID
-     * @param Object $objRecommend
-     */
-    function insertRecommendProduct($arrPost,$member_id, SC_Helper_Recommend_Ex &$objRecommend)
-    {
+     */
+    function insertRecommendProduct($arrPost,$member_id) {
+        $objQuery = $objQuery =& SC_Query_Ex::getSingletonInstance();
         // 古いおすすめ商品のデータを削除する。
-        $this->deleteProduct($arrPost, $objRecommend);
+        $this->deleteProduct($arrPost);
 
         $sqlval = array();
@@ -214,5 +205,8 @@
         $sqlval['comment'] = $arrPost['comment'];
         $sqlval['creator_id'] = $member_id;
-        $objRecommend->save($sqlval);
+        $sqlval['create_date'] = 'CURRENT_TIMESTAMP';
+        $sqlval['update_date'] = 'CURRENT_TIMESTAMP';
+        $sqlval['best_id'] = $objQuery->nextVal('dtb_best_products_best_id');
+        $objQuery->insert('dtb_best_products', $sqlval);
     }
 
@@ -220,16 +214,11 @@
      * データを削除する
      * @param Array $arrPost POSTの値を格納した配列
-     * @param Object $objRecommend
-     * @return void
-     */
-    function deleteProduct($arrPost, SC_Helper_Recommend_Ex &$objRecommend)
-    {
-        if ($arrPost['best_id']) {
-            $target = $arrPost['best_id'];
-        } else {
-            $recommend = $objRecommend->getByRank($arrPost['rank']);
-            $target = $recommend['best_id'];
-        }
-        $objRecommend->delete($target);
+     */
+    function deleteProduct($arrPost) {
+        $objQuery = $objQuery =& SC_Query_Ex::getSingletonInstance();
+        $table = 'dtb_best_products';
+        $where = 'category_id = ? AND rank = ?';
+        $arrWhereVal = array($arrPost['category_id'],$arrPost['rank']);
+        $objQuery->delete($table, $where, $arrWhereVal);
     }
 
@@ -237,16 +226,14 @@
      * 商品情報を取得する
      * @param Integer $product_id 商品ID
-     * @return Array $return 商品のデータを格納した配列
-     */
-    function getProduct($product_id)
-    {
-        $objProduct = new SC_Product_Ex();
-        $arrProduct = $objProduct->getDetail($product_id);
-        $return = array(
-            'product_id' => $arrProduct['product_id'],
-            'main_list_image' => $arrProduct['main_list_image'],
-            'name' => $arrProduct['name']
-        );
-        return $return;
+     * @return Array $arrProduct 商品のデータを格納した配列
+     */
+    function getProduct($product_id) {
+        $objQuery = $objQuery =& SC_Query_Ex::getSingletonInstance();
+        $col = 'product_id,main_list_image,name';
+        $table = 'dtb_products';
+        $where = 'product_id = ? AND del_flg = 0';
+        $arrWhereVal = array($product_id);
+        $arrProduct = $objQuery->select($col, $table, $where, $arrWhereVal);
+        return $arrProduct[0];
     }
 
@@ -256,6 +243,5 @@
      * @param Array $arrItems フロントに表示される商品の情報を格納した配列
      */
-    function setProducts($arrPost,$arrItems)
-    {
+    function setProducts($arrPost,$arrItems) {
         $arrProduct = $this->getProduct($arrPost['product_id']);
         if (count($arrProduct) > 0) {
